#include <bits/stdc++.h>
#define ll long long int
#define MAX_C 30

using namespace std;

int cnt[MAX_C];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int a[n];
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        for(int j = 0; j < MAX_C; j++) {
            if(a[i] & (1 << j)) {
                cnt[j]++;
            }
        }
    }
    int q;
    cin >> q;
    while(q--) {
        int t;
        cin >> t;
        if(t == 0) {
            int k;
            cin >> k;
            int res = 0;
            for(int j = 0; j < MAX_C; j++) {
                if(cnt[j] >= k) {
                    res += (1 << j);
                }
            }
            cout << res << "\n";
        } else {
            int k, x;
            cin >> k >> x;
            for(int j = 0; j < MAX_C; j++) {
                if(a[k - 1] & (1 << j)) {
                    cnt[j]--;
                }
            }
            a[k - 1] = x;
            for(int j = 0; j < MAX_C; j++) {
                if(x & (1 << j)) {
                    cnt[j]++;
                }
            }
        }
    }
    return 0;
}